Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4497)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4498)
@@ -2558,19 +2416,19 @@
 
 
-  END SUBROUTINE vm_data_output
-
-!------------------------------------------------------------------------------!
+ END SUBROUTINE vm_data_output
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Sampling of the actual quantities along the observation coordinates
-!------------------------------------------------------------------------------!
-  SUBROUTINE vm_sampling
-
-    USE radiation_model_mod,                                                   &
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE vm_sampling
+
+    USE radiation_model_mod,                                                                       &
         ONLY:  radiation
 
-    USE surface_mod,                                                           &
-        ONLY:  surf_def_h,                                                     &
-               surf_lsm_h,                                                     &
+    USE surface_mod,                                                                               &
+        ONLY:  surf_def_h,                                                                         &
+               surf_lsm_h,                                                                         &
                surf_usm_h
 
@@ -2585,10 +2443,10 @@
      INTEGER(iwp) ::  nn        !< running index over the number of chemcal species
 
-     LOGICAL ::  match_lsm !< flag indicating natural-type surface
-     LOGICAL ::  match_usm !< flag indicating urban-type surface
-
-     REAL(wp) ::  e_s      !< saturation water vapor pressure
-     REAL(wp) ::  q_s      !< saturation mixing ratio
-     REAL(wp) ::  q_wv     !< mixing ratio
+     LOGICAL ::  match_lsm  !< flag indicating natural-type surface
+     LOGICAL ::  match_usm  !< flag indicating urban-type surface
+
+     REAL(wp) ::  e_s   !< saturation water vapor pressure
+     REAL(wp) ::  q_s   !< saturation mixing ratio
+     REAL(wp) ::  q_wv  !< mixing ratio
 
      CALL cpu_log( log_point_s(27), 'VM sampling', 'start' )
@@ -2598,8 +2456,6 @@
 !
 !--     At the beginning, set _FillValues
-        IF ( ALLOCATED( vmea(l)%measured_vars      ) )                         &
-           vmea(l)%measured_vars      = vmea(l)%fillout
-        IF ( ALLOCATED( vmea(l)%measured_vars_soil ) )                         &
-           vmea(l)%measured_vars_soil = vmea(l)%fillout
+        IF ( ALLOCATED( vmea(l)%measured_vars ) ) vmea(l)%measured_vars = vmea(l)%fillout
+        IF ( ALLOCATED( vmea(l)%measured_vars_soil ) ) vmea(l)%measured_vars_soil = vmea(l)%fillout
 !
 !--     Loop over all variables measured at this site.
@@ -2624,6 +2480,5 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(m,n) = pt(k,j,i) * exner( k )     &
-                                                  - degc_to_k
+                       vmea(l)%measured_vars(m,n) = pt(k,j,i) * exner( k ) - degc_to_k
                     ENDDO
                  ENDIF
@@ -2647,7 +2502,5 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(m,n) = ( q(k,j,i)                 &
-                                                    / ( 1.0_wp - q(k,j,i) ) )  &
-                                                  * rho_air(k)
+                       vmea(l)%measured_vars(m,n) = ( q(k,j,i) / ( 1.0_wp - q(k,j,i) ) ) * rho_air(k)
                     ENDDO
                  ENDIF
@@ -2659,7 +2512,6 @@
 !                        j = vmea(l)%j(m)
 !                        i = vmea(l)%i(m)
-!                        vmea(l)%measured_vars(m,n) = ( q(k,j,i)                 &
-!                                                     / ( 1.0_wp - q(k,j,i) ) )  &
-!                                                   * rho_air(k)
+!                        vmea(l)%measured_vars(m,n) = ( q(k,j,i) / ( 1.0_wp - q(k,j,i) ) )          &
+!                                                     * rho_air(k)
 !                     ENDDO
                  ENDIF
@@ -2672,6 +2524,6 @@
                        i = vmea(l)%i(m)
 !
-!--                    Calculate actual temperature, water vapor saturation
-!--                    pressure, and based on this  the saturation mixing ratio.
+!--                    Calculate actual temperature, water vapor saturation pressure and, based on
+!--                    this, the saturation mixing ratio.
                        e_s  = magnus( exner(k) * pt(k,j,i) )
                        q_s  = rd_d_rv * e_s / ( hyp(k) - e_s )
@@ -2711,7 +2563,7 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = SQRT(                         &
-                                   ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) )**2 + &
-                                   ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) )**2   &
+                    vmea(l)%measured_vars(m,n) = SQRT(                                             &
+                                                 ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) )**2 +       &
+                                                 ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) )**2         &
                                                      )
                  ENDDO
@@ -2723,9 +2575,8 @@
                     i = vmea(l)%i(m)
 
-                    vmea(l)%measured_vars(m,n) = 180.0_wp + 180.0_wp / pi      &
-                                               * ATAN2(                        &
-                                          0.5_wp * ( v(k,j,i) + v(k,j+1,i) ),  &
-                                          0.5_wp * ( u(k,j,i) + u(k,j,i+1) )   &
-                                                      )
+                    vmea(l)%measured_vars(m,n) = 180.0_wp + 180.0_wp / pi * ATAN2(                 &
+                                                 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ),               &
+                                                 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )                &
+                                                                                  )
                  ENDDO
 
@@ -2735,7 +2586,5 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = 0.5_wp *                      &
-                                                 ( u(k,j,i) + u(k,j,i+1) ) *   &
-                                                   pt(k,j,i)
+                    vmea(l)%measured_vars(m,n) = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) * pt(k,j,i)
                  ENDDO
 
@@ -2745,7 +2594,5 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = 0.5_wp *                      &
-                                                 ( v(k,j,i) + v(k,j+1,i) ) *   &
-                                                   pt(k,j,i)
+                    vmea(l)%measured_vars(m,n) = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) * pt(k,j,i)
                  ENDDO
 
@@ -2755,7 +2602,5 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = 0.5_wp *                      &
-                                                 ( w(k-1,j,i) + w(k,j,i) ) *   &
-                                                   pt(k,j,i)
+                    vmea(l)%measured_vars(m,n) = 0.5_wp * ( w(k-1,j,i) + w(k,j,i) ) * pt(k,j,i)
                  ENDDO
 
@@ -2766,7 +2611,5 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(m,n) = 0.5_wp *                   &
-                                                    ( u(k,j,i) + u(k,j,i+1) ) *&
-                                                      q(k,j,i)
+                       vmea(l)%measured_vars(m,n) = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) * q(k,j,i)
                     ENDDO
                  ENDIF
@@ -2778,7 +2621,5 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(m,n) = 0.5_wp *                   &
-                                                    ( v(k,j,i) + v(k,j+1,i) ) *&
-                                                      q(k,j,i)
+                       vmea(l)%measured_vars(m,n) = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) * q(k,j,i)
                     ENDDO
                  ENDIF
@@ -2790,7 +2631,5 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(m,n) = 0.5_wp *                   &
-                                                    ( w(k-1,j,i) + w(k,j,i) ) *&
-                                                      q(k,j,i)
+                       vmea(l)%measured_vars(m,n) = 0.5_wp * ( w(k-1,j,i) + w(k,j,i) ) * q(k,j,i)
                     ENDDO
                  ENDIF
@@ -2801,7 +2640,6 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = 0.25_wp *                     &
-                                                 ( w(k-1,j,i) + w(k,j,i) ) *   &
-                                                 ( u(k,j,i)   + u(k,j,i+1) )
+                    vmea(l)%measured_vars(m,n) = 0.25_wp * ( w(k-1,j,i) + w(k,j,i) ) *             &
+                                                           ( u(k,j,i)   + u(k,j,i+1) )
                  ENDDO
 
@@ -2811,7 +2649,6 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = 0.25_wp *                     &
-                                                 ( w(k-1,j,i) + w(k,j,i) ) *   &
-                                                 ( v(k,j,i)   + v(k,j+1,i) )
+                    vmea(l)%measured_vars(m,n) = 0.25_wp * ( w(k-1,j,i) + w(k,j,i) ) *             &
+                                                           ( v(k,j,i)   + v(k,j+1,i) )
                  ENDDO
 
@@ -2821,15 +2658,12 @@
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    vmea(l)%measured_vars(m,n) = 0.25_wp *                     &
-                                                 ( u(k,j,i)   + u(k,j,i+1) ) * &
-                                                 ( v(k,j,i)   + v(k,j+1,i) )
+                    vmea(l)%measured_vars(m,n) = 0.25_wp * ( u(k,j,i)   + u(k,j,i+1) ) *           &
+                                                           ( v(k,j,i)   + v(k,j+1,i) )
                  ENDDO
 !
-!--           Chemistry variables. List of variables may need extension.
-!--           Note, gas species in PALM are in ppm and no distinction is made
-!--           between mole-fraction and concentration quantities (all are
-!--           output in ppm so far).
-              CASE ( 'mcpm1', 'mcpm2p5', 'mcpm10', 'mfno', 'mfno2',            &
-                     'mcno', 'mcno2', 'tro3' )
+!--           Chemistry variables. List of variables that may need extension. Note, gas species in
+!--           PALM are in ppm and no distinction is made between mole-fraction and concentration
+!--           quantities (all are output in ppm so far).
+              CASE ( 'mcpm1', 'mcpm2p5', 'mcpm10', 'mfno', 'mfno2', 'mcno', 'mcno2', 'tro3' )
                  IF ( air_chemistry )  THEN
 !
@@ -2837,20 +2671,17 @@
 !--                 list, in order to get the internal name of the variable.
                     DO  nn = 1, UBOUND( chem_vars, 2 )
-                       IF ( TRIM( vmea(l)%var_atts(n)%name ) ==                &
+                       IF ( TRIM( vmea(l)%var_atts(n)%name ) ==                                    &
                             TRIM( chem_vars(0,nn) ) )  ind_chem = nn
                     ENDDO
 !
-!--                 Run loop over all chemical species, if the measured
-!--                 variable matches the interal name, sample the variable.
-!--                 Note, nvar as a chemistry-module variable.
+!--                 Run loop over all chemical species, if the measured variable matches the interal
+!--                 name, sample the variable. Note, nvar as a chemistry-module variable.
                     DO  nn = 1, nvar
-                       IF ( TRIM( chem_vars(1,ind_chem) ) ==                   &
-                            TRIM( chem_species(nn)%name ) )  THEN
+                       IF ( TRIM( chem_vars(1,ind_chem) ) == TRIM( chem_species(nn)%name ) )  THEN
                           DO  m = 1, vmea(l)%ns
                              k = vmea(l)%k(m)
                              j = vmea(l)%j(m)
                              i = vmea(l)%i(m)
-                             vmea(l)%measured_vars(m,n) =                      &
-                                                   chem_species(nn)%conc(k,j,i)
+                             vmea(l)%measured_vars(m,n) = chem_species(nn)%conc(k,j,i)
                           ENDDO
                        ENDIF
@@ -2861,6 +2692,6 @@
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not
-!--                 on ghost points. Hence, limit the indices.
+!--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+!--                 limit the indices.
                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                     j = MERGE( j           , nyn, j            < nyn )
@@ -2868,14 +2699,11 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_def_h(0)%start_index(j,i),                   &
-                             surf_def_h(0)%end_index(j,i)
+                    DO  mm = surf_def_h(0)%start_index(j,i), surf_def_h(0)%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%us(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i),                      &
-                             surf_lsm_h%end_index(j,i)
+                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_lsm_h%us(mm)
                     ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i),                      &
-                             surf_usm_h%end_index(j,i)
+                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_usm_h%us(mm)
                     ENDDO
@@ -2885,6 +2713,6 @@
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not
-!--                 on ghost points. Hence, limit the indices.
+!--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+!-                  limit the indices.
                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                     j = MERGE( j           , nyn, j            < nyn )
@@ -2892,14 +2720,11 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_def_h(0)%start_index(j,i),                   &
-                             surf_def_h(0)%end_index(j,i)
+                    DO  mm = surf_def_h(0)%start_index(j,i), surf_def_h(0)%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%ts(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i),                      &
-                             surf_lsm_h%end_index(j,i)
+                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_lsm_h%ts(mm)
                     ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i),                      &
-                             surf_usm_h%end_index(j,i)
+                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_usm_h%ts(mm)
                     ENDDO
@@ -2909,6 +2734,6 @@
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not
-!--                 on ghost points. Hence, limit the indices.
+!--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+!--                 limit the indices.
                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                     j = MERGE( j           , nyn, j            < nyn )
@@ -2916,14 +2741,11 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_def_h(0)%start_index(j,i),                   &
-                             surf_def_h(0)%end_index(j,i)
+                    DO  mm = surf_def_h(0)%start_index(j,i), surf_def_h(0)%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%qsws(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i),                      &
-                             surf_lsm_h%end_index(j,i)
+                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_lsm_h%qsws(mm)
                     ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i),                      &
-                             surf_usm_h%end_index(j,i)
+                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_usm_h%qsws(mm)
                     ENDDO
@@ -2933,6 +2755,6 @@
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not
-!--                 on ghost points. Hence, limit the indices.
+!--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+!--                 limit the indices.
                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                     j = MERGE( j           , nyn, j            < nyn )
@@ -2940,14 +2762,11 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_def_h(0)%start_index(j,i),                   &
-                             surf_def_h(0)%end_index(j,i)
+                    DO  mm = surf_def_h(0)%start_index(j,i), surf_def_h(0)%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_def_h(0)%shf(mm)
                     ENDDO
-                    DO  mm = surf_lsm_h%start_index(j,i),                      &
-                             surf_lsm_h%end_index(j,i)
+                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_lsm_h%shf(mm)
                     ENDDO
-                    DO  mm = surf_usm_h%start_index(j,i),                      &
-                             surf_usm_h%end_index(j,i)
+                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_usm_h%shf(mm)
                     ENDDO
@@ -2957,6 +2776,6 @@
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not
-!--                 on ghost points. Hence, limit the indices.
+!--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+!--                 limit the indices.
                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                     j = MERGE( j           , nyn, j            < nyn )
@@ -2964,6 +2783,5 @@
                     i = MERGE( i           , nxr, i            < nxr )
 
-                    DO  mm = surf_lsm_h%start_index(j,i),                      &
-                             surf_lsm_h%end_index(j,i)
+                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                        vmea(l)%measured_vars(m,n) = surf_lsm_h%ghf(mm)
                     ENDDO
@@ -2973,6 +2791,6 @@
 !                  DO  m = 1, vmea(l)%ns
 ! !
-! !--                 Surface data is only available on inner subdomains, not
-! !--                 on ghost points. Hence, limit the indices.
+! !--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+! !--                 limit the indices.
 !                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
 !                     j = MERGE( j           , nyn, j            < nyn )
@@ -2980,6 +2798,5 @@
 !                     i = MERGE( i           , nxr, i            < nxr )
 !
-!                     DO  mm = surf_lsm_h%start_index(j,i),                      &
-!                              surf_lsm_h%end_index(j,i)
+!                     DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
 !                        vmea(l)%measured_vars(m,n) = ?
 !                     ENDDO
@@ -2990,6 +2807,6 @@
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not
-!--                    on ghost points. Hence, limit the indices.
+!--                    Surface data is only available on inner subdomains, not on ghost points.
+!--                    Hence, limit the indices.
                        j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                        j = MERGE( j           , nyn, j            < nyn )
@@ -2997,10 +2814,8 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i),                   &
-                                surf_lsm_h%end_index(j,i)
+                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_net(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i),                   &
-                                surf_usm_h%end_index(j,i)
+                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_usm_h%rad_net(mm)
                        ENDDO
@@ -3012,6 +2827,6 @@
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not
-!--                    on ghost points. Hence, limit the indices.
+!--                    Surface data is only available on inner subdomains, not on ghost points.
+!--                    Hence, limit the indices.
                        j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                        j = MERGE( j           , nyn, j            < nyn )
@@ -3019,10 +2834,8 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i),                   &
-                                surf_lsm_h%end_index(j,i)
+                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_sw_out(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i),                   &
-                                surf_usm_h%end_index(j,i)
+                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_usm_h%rad_sw_out(mm)
                        ENDDO
@@ -3034,6 +2847,6 @@
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not
-!--                    on ghost points. Hence, limit the indices.
+!--                    Surface data is only available on inner subdomains, not on ghost points.
+!--                    Hence, limit the indices.
                        j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                        j = MERGE( j           , nyn, j            < nyn )
@@ -3041,10 +2854,8 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i),                   &
-                                surf_lsm_h%end_index(j,i)
+                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_sw_in(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i),                   &
-                                surf_usm_h%end_index(j,i)
+                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_usm_h%rad_sw_in(mm)
                        ENDDO
@@ -3056,6 +2867,6 @@
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not
-!--                    on ghost points. Hence, limit the indices.
+!--                    Surface data is only available on inner subdomains, not on ghost points.
+!--                    Hence, limit the indices.
                        j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                        j = MERGE( j           , nyn, j            < nyn )
@@ -3063,10 +2874,8 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i),                   &
-                                surf_lsm_h%end_index(j,i)
+                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_lw_out(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i),                   &
-                                surf_usm_h%end_index(j,i)
+                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_usm_h%rad_lw_out(mm)
                        ENDDO
@@ -3078,6 +2887,6 @@
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not
-!--                    on ghost points. Hence, limit the indices.
+!--                    Surface data is only available on inner subdomains, not on ghost points.
+!--                    Hence, limit the indices.
                        j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                        j = MERGE( j           , nyn, j            < nyn )
@@ -3085,10 +2894,8 @@
                        i = MERGE( i           , nxr, i            < nxr )
 
-                       DO  mm = surf_lsm_h%start_index(j,i),                   &
-                                surf_lsm_h%end_index(j,i)
+                       DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_lsm_h%rad_lw_in(mm)
                        ENDDO
-                       DO  mm = surf_usm_h%start_index(j,i),                   &
-                                surf_usm_h%end_index(j,i)
+                       DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                           vmea(l)%measured_vars(m,n) = surf_usm_h%rad_lw_in(mm)
                        ENDDO
@@ -3159,6 +2966,6 @@
                           k = 0
 !
-!--                       Surface data is only available on inner subdomains,
-!--                       not on ghost points. Hence, limit the indices.
+!--                       Surface data is only available on inner subdomains, not on ghost points.
+!--                       Hence, limit the indices.
                           j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
                           j = MERGE( j           , nyn, j            < nyn )
@@ -3196,8 +3003,6 @@
                     k = vmea(l)%k_soil(m)
 
-                    match_lsm = surf_lsm_h%start_index(j,i) <=                 &
-                                surf_lsm_h%end_index(j,i)
-                    match_usm = surf_usm_h%start_index(j,i) <=                 &
-                                surf_usm_h%end_index(j,i)
+                    match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                    match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                     IF ( match_lsm )  THEN
@@ -3220,6 +3025,5 @@
                     k = vmea(l)%k_soil(m)
 
-                    match_lsm = surf_lsm_h%start_index(j,i) <=                 &
-                                surf_lsm_h%end_index(j,i)
+                    match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
 
                     IF ( match_lsm )  THEN
@@ -3231,4 +3035,45 @@
 
               CASE ( 'ts' ) ! surface temperature
+                 DO  m = 1, vmea(l)%ns
+!
+!--                 Surface data is only available on inner subdomains, not on ghost points. Hence,
+!--                 limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
+                    DO  mm = surf_def_h(0)%start_index(j,i), surf_def_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_def_h(0)%pt_surface(mm)
+                    ENDDO
+                    DO  mm = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%pt_surface(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h%pt_surface(mm)
+                    ENDDO
+                 ENDDO
+
+              CASE ( 'lwp' ) ! liquid water path
+                 IF ( ASSOCIATED( ql ) )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+
+                       vmea(l)%measured_vars(m,n) = SUM( ql(nzb:nzt,j,i) * dzw(1:nzt+1) )          &
+                                                    * rho_surface
+                    ENDDO
+                 ENDIF
+
+              CASE ( 'ps' ) ! surface pressure
+                 vmea(l)%measured_vars(:,n) = surface_pressure
+
+              CASE ( 'pswrtg' ) ! platform speed above ground
+                 vmea(l)%measured_vars(:,n) = 0.0_wp
+
+              CASE ( 'pswrta' ) ! platform speed in air
+                 vmea(l)%measured_vars(:,n) = 0.0_wp
+
+              CASE ( 't_lw' ) ! water temperature
                  DO  m = 1, vmea(l)%ns
 !
